/*----- PROTECTED REGION ID(DSManagerTestClass.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        DSManagerTestClass.cpp
//
// description : C++ source for the DSManagerTestClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the DSManagerTest once per process.
//
// project :     DSManagerTest
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <DSManagerTestClass.h>

/*----- PROTECTED REGION END -----*/	//	DSManagerTestClass.cpp

//-------------------------------------------------------------------
/**
 *	Create DSManagerTestClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_DSManagerTest_class(const char *name) {
		return DSManagerTest_ns::DSManagerTestClass::init(name);
	}
}

namespace DSManagerTest_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
DSManagerTestClass *DSManagerTestClass::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		DSManagerTestClass::DSManagerTestClass(string &s)
 * description : 	constructor for the DSManagerTestClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
DSManagerTestClass::DSManagerTestClass(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering DSManagerTestClass constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(DSManagerTestClass::constructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTestClass::constructor

	cout2 << "Leaving DSManagerTestClass constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		DSManagerTestClass::~DSManagerTestClass()
 * description : 	destructor for the DSManagerTestClass
 */
//--------------------------------------------------------
DSManagerTestClass::~DSManagerTestClass()
{
	/*----- PROTECTED REGION ID(DSManagerTestClass::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTestClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		DSManagerTestClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
DSManagerTestClass *DSManagerTestClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new DSManagerTestClass(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		DSManagerTestClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
DSManagerTestClass *DSManagerTestClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================

//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : DSManagerTestClass::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum DSManagerTestClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : DSManagerTestClass::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum DSManagerTestClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : DSManagerTestClass::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum DSManagerTestClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : DSManagerTestClass::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void DSManagerTestClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
}

//--------------------------------------------------------
/**
 *	Method      : DSManagerTestClass::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void DSManagerTestClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("DSManagerTest");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("DSManagerTest");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : DSManagerTestClass::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void DSManagerTestClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(DSManagerTestClass::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTestClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new DSManagerTest(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		DSManagerTest *dev = static_cast<DSManagerTest *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(DSManagerTestClass::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTestClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : DSManagerTestClass::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void DSManagerTestClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(DSManagerTestClass::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTestClass::attribute_factory_before
	//	Attribute : ds_mode
	ds_modeAttrib	*ds_mode = new ds_modeAttrib();
	Tango::UserDefaultAttrProp	ds_mode_prop;
	//	description	not set for ds_mode
	//	label	not set for ds_mode
	//	unit	not set for ds_mode
	//	standard_unit	not set for ds_mode
	//	display_unit	not set for ds_mode
	//	format	not set for ds_mode
	//	max_value	not set for ds_mode
	//	min_value	not set for ds_mode
	//	max_alarm	not set for ds_mode
	//	min_alarm	not set for ds_mode
	//	max_warning	not set for ds_mode
	//	min_warning	not set for ds_mode
	//	delta_t	not set for ds_mode
	//	delta_val	not set for ds_mode
	ds_mode_prop.set_event_period("1000");
	
	{
		vector<string> labels;
		labels.push_back("OFF");
		labels.push_back("STARTUP");
		labels.push_back("STANDBY-LP");
		labels.push_back("STOW");
		labels.push_back("ESTOP");
		labels.push_back("POINT");
		labels.push_back("MAINTENANCE");
		labels.push_back("UNKNOWN");
		labels.push_back("STANDBY-FP");
		ds_mode_prop.set_enum_labels(labels);
	}
	ds_mode->set_default_properties(ds_mode_prop);
	ds_mode->set_polling_period(1000);
	ds_mode->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	ds_mode->set_change_event(true, false);
	att_list.push_back(ds_mode);

	//	Attribute : ds_powerState
	ds_powerStateAttrib	*ds_powerstate = new ds_powerStateAttrib();
	Tango::UserDefaultAttrProp	ds_powerstate_prop;
	//	description	not set for ds_powerState
	//	label	not set for ds_powerState
	//	unit	not set for ds_powerState
	//	standard_unit	not set for ds_powerState
	//	display_unit	not set for ds_powerState
	//	format	not set for ds_powerState
	//	max_value	not set for ds_powerState
	//	min_value	not set for ds_powerState
	//	max_alarm	not set for ds_powerState
	//	min_alarm	not set for ds_powerState
	//	max_warning	not set for ds_powerState
	//	min_warning	not set for ds_powerState
	//	delta_t	not set for ds_powerState
	//	delta_val	not set for ds_powerState
	ds_powerstate_prop.set_event_period("1000");
	
	{
		vector<string> labels;
		labels.push_back("OFF");
		labels.push_back("LOW-POWER");
		labels.push_back("FULL-POWER");
		ds_powerstate_prop.set_enum_labels(labels);
	}
	ds_powerstate->set_default_properties(ds_powerstate_prop);
	ds_powerstate->set_polling_period(1000);
	ds_powerstate->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	ds_powerstate->set_change_event(true, false);
	att_list.push_back(ds_powerstate);

	//	Attribute : ind_Position
	ind_PositionAttrib	*ind_position = new ind_PositionAttrib();
	Tango::UserDefaultAttrProp	ind_position_prop;
	//	description	not set for ind_Position
	//	label	not set for ind_Position
	//	unit	not set for ind_Position
	//	standard_unit	not set for ind_Position
	//	display_unit	not set for ind_Position
	//	format	not set for ind_Position
	//	max_value	not set for ind_Position
	//	min_value	not set for ind_Position
	//	max_alarm	not set for ind_Position
	//	min_alarm	not set for ind_Position
	//	max_warning	not set for ind_Position
	//	min_warning	not set for ind_Position
	//	delta_t	not set for ind_Position
	//	delta_val	not set for ind_Position
	ind_position_prop.set_event_period("1000");
	
	{
		vector<string> labels;
		labels.push_back("B1");
		labels.push_back("B2");
		labels.push_back("B3");
		labels.push_back("B4");
		labels.push_back("B5");
		labels.push_back("MOVING");
		labels.push_back("ERROR");
		labels.push_back("UNKNOWN");
		ind_position_prop.set_enum_labels(labels);
	}
	ind_position->set_default_properties(ind_position_prop);
	ind_position->set_polling_period(1000);
	ind_position->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	ind_position->set_change_event(true, false);
	att_list.push_back(ind_position);

	//	Attribute : ds_mode_test
	ds_mode_testAttrib	*ds_mode_test = new ds_mode_testAttrib();
	Tango::UserDefaultAttrProp	ds_mode_test_prop;
	//	description	not set for ds_mode_test
	//	label	not set for ds_mode_test
	//	unit	not set for ds_mode_test
	//	standard_unit	not set for ds_mode_test
	//	display_unit	not set for ds_mode_test
	//	format	not set for ds_mode_test
	//	max_value	not set for ds_mode_test
	//	min_value	not set for ds_mode_test
	//	max_alarm	not set for ds_mode_test
	//	min_alarm	not set for ds_mode_test
	//	max_warning	not set for ds_mode_test
	//	min_warning	not set for ds_mode_test
	//	delta_t	not set for ds_mode_test
	//	delta_val	not set for ds_mode_test
	ds_mode_test_prop.set_event_period("5000");
	
	{
		vector<string> labels;
		labels.push_back("OFF");
		labels.push_back("STARTUP");
		labels.push_back("STANDBY");
		labels.push_back("STOW");
		labels.push_back("ESTOP");
		labels.push_back("POINT");
		labels.push_back("MAINTENANCE");
		labels.push_back("ERROR");
		labels.push_back("UNKNOWN");
		ds_mode_test_prop.set_enum_labels(labels);
	}
	ds_mode_test->set_default_properties(ds_mode_test_prop);
	ds_mode_test->set_polling_period(5000);
	ds_mode_test->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	ds_mode_test->set_change_event(true, false);
	att_list.push_back(ds_mode_test);

	//	Attribute : ds_powerState_test
	ds_powerState_testAttrib	*ds_powerstate_test = new ds_powerState_testAttrib();
	Tango::UserDefaultAttrProp	ds_powerstate_test_prop;
	//	description	not set for ds_powerState_test
	//	label	not set for ds_powerState_test
	//	unit	not set for ds_powerState_test
	//	standard_unit	not set for ds_powerState_test
	//	display_unit	not set for ds_powerState_test
	//	format	not set for ds_powerState_test
	//	max_value	not set for ds_powerState_test
	//	min_value	not set for ds_powerState_test
	//	max_alarm	not set for ds_powerState_test
	//	min_alarm	not set for ds_powerState_test
	//	max_warning	not set for ds_powerState_test
	//	min_warning	not set for ds_powerState_test
	//	delta_t	not set for ds_powerState_test
	//	delta_val	not set for ds_powerState_test
	ds_powerstate_test_prop.set_event_period("5000");
	
	{
		vector<string> labels;
		labels.push_back("UPS");
		labels.push_back("FULL-POWER");
		labels.push_back("LOW-POWER");
		labels.push_back("UNKNOWN");
		ds_powerstate_test_prop.set_enum_labels(labels);
	}
	ds_powerstate_test->set_default_properties(ds_powerstate_test_prop);
	ds_powerstate_test->set_polling_period(5000);
	ds_powerstate_test->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	ds_powerstate_test->set_change_event(true, false);
	att_list.push_back(ds_powerstate_test);

	//	Attribute : stowStatus
	stowStatusAttrib	*stowstatus = new stowStatusAttrib();
	Tango::UserDefaultAttrProp	stowstatus_prop;
	//	description	not set for stowStatus
	//	label	not set for stowStatus
	//	unit	not set for stowStatus
	//	standard_unit	not set for stowStatus
	//	display_unit	not set for stowStatus
	//	format	not set for stowStatus
	//	max_value	not set for stowStatus
	//	min_value	not set for stowStatus
	//	max_alarm	not set for stowStatus
	//	min_alarm	not set for stowStatus
	//	max_warning	not set for stowStatus
	//	min_warning	not set for stowStatus
	//	delta_t	not set for stowStatus
	//	delta_val	not set for stowStatus
	stowstatus_prop.set_event_period("3000");
	
	stowstatus->set_default_properties(stowstatus_prop);
	stowstatus->set_polling_period(3000);
	stowstatus->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	stowstatus->set_change_event(true, false);
	att_list.push_back(stowstatus);

	//	Attribute : indexingStatus
	indexingStatusAttrib	*indexingstatus = new indexingStatusAttrib();
	Tango::UserDefaultAttrProp	indexingstatus_prop;
	//	description	not set for indexingStatus
	//	label	not set for indexingStatus
	//	unit	not set for indexingStatus
	//	standard_unit	not set for indexingStatus
	//	display_unit	not set for indexingStatus
	//	format	not set for indexingStatus
	//	max_value	not set for indexingStatus
	//	min_value	not set for indexingStatus
	//	max_alarm	not set for indexingStatus
	//	min_alarm	not set for indexingStatus
	//	max_warning	not set for indexingStatus
	//	min_warning	not set for indexingStatus
	//	delta_t	not set for indexingStatus
	//	delta_val	not set for indexingStatus
	indexingstatus_prop.set_event_period("3000");
	
	indexingstatus->set_default_properties(indexingstatus_prop);
	indexingstatus->set_polling_period(3000);
	indexingstatus->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	indexingstatus->set_change_event(true, false);
	att_list.push_back(indexingstatus);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(DSManagerTestClass::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTestClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : DSManagerTestClass::pipe_factory()
 *	Description : Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void DSManagerTestClass::pipe_factory()
{
	/*----- PROTECTED REGION ID(DSManagerTestClass::pipe_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTestClass::pipe_factory_before
	/*----- PROTECTED REGION ID(DSManagerTestClass::pipe_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTestClass::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : DSManagerTestClass::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void DSManagerTestClass::command_factory()
{
	/*----- PROTECTED REGION ID(DSManagerTestClass::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTestClass::command_factory_before


	/*----- PROTECTED REGION ID(DSManagerTestClass::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTestClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		DSManagerTestClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list
 */
//--------------------------------------------------------
void DSManagerTestClass::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(DSManagerTestClass::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTestClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		DSManagerTestClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void DSManagerTestClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		DSManagerTest *dev = static_cast<DSManagerTest *> (dev_impl);

		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(DSManagerTestClass::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTestClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : DSManagerTestClass::get_attr_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *DSManagerTestClass::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(DSManagerTestClass::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	DSManagerTestClass::Additional Methods
} //	namespace
