

#include <EventCallBack.h>
#include <EventListener.h>


#include <tango.h>

//## Standard headers
#include <iostream>
#include <string>
#include <sstream>
#include <fstream>
#include <iomanip>
#include <stdio.h>
#include <signal.h>
#include <ctime>
#include <stdexcept>
#include <stdlib.h>

#include <ratio>
#include <chrono>
#include <map>
#include <vector>

using namespace std;

namespace EventListener_ns {

EventListener* EventCallBack::m_dev= 0;

EventCallBack::EventCallBack (EventListener* dev) 
	: Tango::LogAdapter(dev)
{
  
	m_dev = dev;
	m_logger= 0;
	if(dev) m_logger= Tango::LogAdapter(dev).get_logger();
	
}//close constructor
	

EventCallBack::~EventCallBack(){

}//destructor


void EventCallBack::push_event(Tango::EventData* event) { 
    
	//## Get access to event info
	/*
	[device] : The DeviceProxy object on which the call was executed (Tango::DeviceProxy *)
	[attr_name] : The attribute name (std::string &)
	[event] : The event name (std::string &)
	[attr_value] : The attribute data (DeviceAttribute *)
	[err] : A boolean flag set to true if the request failed. False otherwise (bool)
	[errors] : The error stack (DevErrorList &)
	*/

	if(!m_dev) {
		return;
	}

	if(!event){
		std::string errMsg("Null ptr to event data!");
		m_logger->warn(errMsg);
		return;
	}
	
	std::string event_attr_name= event->attr_name;
	if (event->err) {
		std::stringstream ss;
		ss<<"Invalid event "<<event_attr_name<<" received... skip processing!";
		m_logger->warn(ss.str());
		return;
	}
  
	std::stringstream infoMsgStream;
	infoMsgStream<<"Event "<<event_attr_name<<" received";
 	m_logger->info(infoMsgStream.str());
	
	
}//close EventCallBack::push_event()



}//close namespace


