/*----- PROTECTED REGION ID(EventListener.h) ENABLED START -----*/
//=============================================================================
//
// file :        EventListener.h
//
// description : Include file for the EventListener class
//
// project :     EventListener
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef EventListener_H
#define EventListener_H

#include <tango.h>

#include <EventCallBack.h>


/*----- PROTECTED REGION END -----*/	//	EventListener.h

/**
 *  EventListener class description:
 *    EventListener
 */

namespace EventListener_ns
{
/*----- PROTECTED REGION ID(EventListener::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations
	class EventCallBack;

/*----- PROTECTED REGION END -----*/	//	EventListener::Additional Class Declarations

class EventListener : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(EventListener::Data Members) ENABLED START -----*/

//	Add your own data members
	protected:
		//- Event callback
		EventCallBack* m_eventCallBack;
		EventCallBack* m_eventCallBack2;

		//- Device proxy
		Tango::DeviceProxy* m_proxy;	
		Tango::DeviceProxy* rx_proxy;
		Tango::DeviceProxy* spf_proxy;	
		Tango::DeviceProxy* ds_proxy;

		//- Event counter
		omni_mutex m_mutex;
		std::map<std::string,long> m_eventCounterMap;

/*----- PROTECTED REGION END -----*/	//	EventListener::Data Members

//	Device property data members
public:
	//	rx_proxy_name:	
	string	rx_proxy_name;
	//	spf_proxy_name:	
	string	spf_proxy_name;
	//	ds_proxy_name:	
	string	ds_proxy_name;


//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	EventListener(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	EventListener(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	EventListener(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~EventListener() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : EventListener::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);


	//--------------------------------------------------------
	/**
	 *	Method      : EventListener::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:


	//--------------------------------------------------------
	/**
	 *	Method      : EventListener::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(EventListener::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes

	
		friend class EventCallBack;

/*----- PROTECTED REGION END -----*/	//	EventListener::Additional Method prototypes
};

/*----- PROTECTED REGION ID(EventListener::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	EventListener::Additional Classes Definitions

}	//	End of namespace

#endif   //	EventListener_H
