/*----- PROTECTED REGION ID(SPFEmulatorTest.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        SPFEmulatorTest.cpp
//
// description : C++ source for the SPFEmulatorTest class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               SPFEmulatorTest are implemented in this file.
//
// project :     SPFEmulatorTest
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <SPFEmulatorTest.h>
#include <SPFEmulatorTestClass.h>

/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest.cpp

/**
 *  SPFEmulatorTest class description:
 *    SPFEmulatorTest
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  spf_mode            |  Tango::DevEnum	Scalar
//  b1_capabilityState  |  Tango::DevEnum	Scalar
//  b2_capabilityState  |  Tango::DevEnum	Scalar
//  b3_capabilityState  |  Tango::DevEnum	Scalar
//  b4_capabilityState  |  Tango::DevEnum	Scalar
//  b5_capabilityState  |  Tango::DevEnum	Scalar
//  spf_mode_test       |  Tango::DevEnum	Scalar
//  operateStatus       |  Tango::DevString	Spectrum  ( max = 2)
//================================================================

namespace SPFEmulatorTest_ns
{
/*----- PROTECTED REGION ID(SPFEmulatorTest::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : SPFEmulatorTest::SPFEmulatorTest()
 *	Description : Constructors for a Tango device
 *                implementing the classSPFEmulatorTest
 */
//--------------------------------------------------------
SPFEmulatorTest::SPFEmulatorTest(Tango::DeviceClass *cl, string &s)
 : TANGO_BASE_CLASS(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(SPFEmulatorTest::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::constructor_1
}
//--------------------------------------------------------
SPFEmulatorTest::SPFEmulatorTest(Tango::DeviceClass *cl, const char *s)
 : TANGO_BASE_CLASS(cl, s)
{
	/*----- PROTECTED REGION ID(SPFEmulatorTest::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::constructor_2
}
//--------------------------------------------------------
SPFEmulatorTest::SPFEmulatorTest(Tango::DeviceClass *cl, const char *s, const char *d)
 : TANGO_BASE_CLASS(cl, s, d)
{
	/*----- PROTECTED REGION ID(SPFEmulatorTest::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : SPFEmulatorTest::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void SPFEmulatorTest::delete_device()
{
	DEBUG_STREAM << "SPFEmulatorTest::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(SPFEmulatorTest::delete_device) ENABLED START -----*/
	
	//	Delete device allocated objects
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::delete_device
	delete[] attr_spf_mode_read;
	delete[] attr_b1_capabilityState_read;
	delete[] attr_b2_capabilityState_read;
	delete[] attr_b3_capabilityState_read;
	delete[] attr_b4_capabilityState_read;
	delete[] attr_b5_capabilityState_read;
	delete[] attr_spf_mode_test_read;
	delete[] attr_operateStatus_read;
}

//--------------------------------------------------------
/**
 *	Method      : SPFEmulatorTest::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void SPFEmulatorTest::init_device()
{
	DEBUG_STREAM << "SPFEmulatorTest::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(SPFEmulatorTest::init_device_before) ENABLED START -----*/
	
	//	Initialization before get_device_property() call
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::init_device_before
	
	//	No device property to be read from database
	
	attr_spf_mode_read = new spf_modeEnum[1];
	attr_b1_capabilityState_read = new b1_capabilityStateEnum[1];
	attr_b2_capabilityState_read = new b2_capabilityStateEnum[1];
	attr_b3_capabilityState_read = new b3_capabilityStateEnum[1];
	attr_b4_capabilityState_read = new b4_capabilityStateEnum[1];
	attr_b5_capabilityState_read = new b5_capabilityStateEnum[1];
	attr_spf_mode_test_read = new spf_mode_testEnum[1];
	attr_operateStatus_read = new Tango::DevString[2];
	/*----- PROTECTED REGION ID(SPFEmulatorTest::init_device) ENABLED START -----*/
	
	//	Initialize device
	*attr_spf_mode_read= spf_modeEnum::_UNKNOWN;
	*attr_b1_capabilityState_read= b1_capabilityStateEnum::_UNKNOWN;	
	*attr_b2_capabilityState_read= b2_capabilityStateEnum::_UNKNOWN;	
	*attr_b3_capabilityState_read= b3_capabilityStateEnum::_UNKNOWN;	
	*attr_b4_capabilityState_read= b4_capabilityStateEnum::_UNKNOWN;	
	*attr_b5_capabilityState_read= b5_capabilityStateEnum::_UNKNOWN;	
	*attr_spf_mode_test_read= spf_mode_testEnum::_UNKNOWN;

	attr_operateStatus_read[0]= Tango::string_dup("INIT");
	attr_operateStatus_read[1]= Tango::string_dup("No info present");

	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::init_device
}


//--------------------------------------------------------
/**
 *	Method      : SPFEmulatorTest::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void SPFEmulatorTest::always_executed_hook()
{
	DEBUG_STREAM << "SPFEmulatorTest::always_executed_hook()  " << device_name << endl;
	/*----- PROTECTED REGION ID(SPFEmulatorTest::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : SPFEmulatorTest::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void SPFEmulatorTest::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "SPFEmulatorTest::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(SPFEmulatorTest::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::read_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute spf_mode related method
 *	Description: 
 *
 *	Data type:	Tango::DevEnum (spf_modeEnum)
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void SPFEmulatorTest::read_spf_mode(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SPFEmulatorTest::read_spf_mode(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(SPFEmulatorTest::read_spf_mode) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_spf_mode_read);
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::read_spf_mode
}
//--------------------------------------------------------
/**
 *	Read attribute b1_capabilityState related method
 *	Description: 
 *
 *	Data type:	Tango::DevEnum (b1_capabilityStateEnum)
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void SPFEmulatorTest::read_b1_capabilityState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SPFEmulatorTest::read_b1_capabilityState(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(SPFEmulatorTest::read_b1_capabilityState) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_b1_capabilityState_read);
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::read_b1_capabilityState
}
//--------------------------------------------------------
/**
 *	Read attribute b2_capabilityState related method
 *	Description: 
 *
 *	Data type:	Tango::DevEnum (b2_capabilityStateEnum)
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void SPFEmulatorTest::read_b2_capabilityState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SPFEmulatorTest::read_b2_capabilityState(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(SPFEmulatorTest::read_b2_capabilityState) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_b2_capabilityState_read);
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::read_b2_capabilityState
}
//--------------------------------------------------------
/**
 *	Read attribute b3_capabilityState related method
 *	Description: 
 *
 *	Data type:	Tango::DevEnum (b3_capabilityStateEnum)
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void SPFEmulatorTest::read_b3_capabilityState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SPFEmulatorTest::read_b3_capabilityState(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(SPFEmulatorTest::read_b3_capabilityState) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_b3_capabilityState_read);
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::read_b3_capabilityState
}
//--------------------------------------------------------
/**
 *	Read attribute b4_capabilityState related method
 *	Description: 
 *
 *	Data type:	Tango::DevEnum (b4_capabilityStateEnum)
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void SPFEmulatorTest::read_b4_capabilityState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SPFEmulatorTest::read_b4_capabilityState(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(SPFEmulatorTest::read_b4_capabilityState) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_b4_capabilityState_read);
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::read_b4_capabilityState
}
//--------------------------------------------------------
/**
 *	Read attribute b5_capabilityState related method
 *	Description: 
 *
 *	Data type:	Tango::DevEnum (b5_capabilityStateEnum)
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void SPFEmulatorTest::read_b5_capabilityState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SPFEmulatorTest::read_b5_capabilityState(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(SPFEmulatorTest::read_b5_capabilityState) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_b5_capabilityState_read);
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::read_b5_capabilityState
}
//--------------------------------------------------------
/**
 *	Read attribute spf_mode_test related method
 *	Description: 
 *
 *	Data type:	Tango::DevEnum (spf_mode_testEnum)
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void SPFEmulatorTest::read_spf_mode_test(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SPFEmulatorTest::read_spf_mode_test(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(SPFEmulatorTest::read_spf_mode_test) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_spf_mode_test_read);
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::read_spf_mode_test
}
//--------------------------------------------------------
/**
 *	Read attribute operateStatus related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 2
 */
//--------------------------------------------------------
void SPFEmulatorTest::read_operateStatus(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SPFEmulatorTest::read_operateStatus(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(SPFEmulatorTest::read_operateStatus) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_operateStatus_read, 2);
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::read_operateStatus
}

//--------------------------------------------------------
/**
 *	Method      : SPFEmulatorTest::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void SPFEmulatorTest::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(SPFEmulatorTest::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : SPFEmulatorTest::add_dynamic_commands()
 *	Description : Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void SPFEmulatorTest::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(SPFEmulatorTest::add_dynamic_commands) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic commands if any
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::add_dynamic_commands
}

/*----- PROTECTED REGION ID(SPFEmulatorTest::namespace_ending) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::namespace_ending
} //	namespace
